//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern string TimeFrame               = "Current time frame";
extern int    SSAPrice                = PRICE_CLOSE;
extern int    SSALag                  = 25;
extern int    SSANumberOfComputations = 2;
extern int    SSANumberOfBars         = 300;
extern int    FirstBar                = 300; 
extern bool   MultiColor              = true;


//
//
//
//
//

double in[];
double ssaDa[];
double ssaDb[];
double pr[];
double slope[];
double ssaIn[];
double ssaOut[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,in);
      SetIndexBuffer(1,ssaDa);
      SetIndexBuffer(2,ssaDb);
      SetIndexBuffer(3,pr);
      SetIndexBuffer(4,slope);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" SSA normalized end-pointed");
   return(0);
}
int deinit(){return(0);}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);
      if (returnBars) { in[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (calculateValue || timeFrame==Period())
   {
     if (MultiColor && slope[limit]==-1) CleanPoint(limit,ssaDa,ssaDb);
     for(i=limit; i>=0; i--)
     {
        pr[i] = iMA(NULL,0,1,0,MODE_SMA,SSAPrice,i);

        //
        //
        //
        //
        //
      
        if (i<=FirstBar)
        {
           int ssaBars = MathMin(Bars-i,SSANumberOfBars);
           if (ssaBars<SSALag) continue;
              if (ArraySize(ssaIn) != ssaBars)
              {
                 ArrayResize(ssaIn ,ssaBars);
                 ArrayResize(ssaOut,ssaBars);
              }
              ArrayCopy(ssaIn,pr,0,i,ssaBars);
      
          fastSingular(ssaIn,ssaBars,SSALag,SSANumberOfComputations,ssaOut);
          in[i]=ssaOut[0];
          
          ssaDa[i] = EMPTY_VALUE;
          ssaDb[i] = EMPTY_VALUE;
          slope[i] = slope[i+1];

          if (in[i]<in[i+1]) slope[i] = -1;
          if (in[i]>in[i+1]) slope[i] =  1;
          if (MultiColor && slope[i] == -1) PlotPoint(i,ssaDa,ssaDb,in);
       }                   
   }
   SetIndexDrawBegin(0,Bars-FirstBar);  
   SetIndexDrawBegin(1,Bars-FirstBar);
   SetIndexDrawBegin(2,Bars-FirstBar);                  
   return(0); 
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColor && slope[limit]==-1) CleanPoint(limit,ssaDa,ssaDb);
   for(i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         in[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,y);
         ssaDa[i] = EMPTY_VALUE;
         ssaDb[i] = EMPTY_VALUE;
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,4,y);
   }
   SetIndexDrawBegin(0,Bars-FirstBar*timeFrame/Period());
   SetIndexDrawBegin(1,Bars-FirstBar*timeFrame/Period());
   SetIndexDrawBegin(2,Bars-FirstBar*timeFrame/Period());
   for(i=limit; i>=0; i--) if (MultiColor && slope[i] == -1) PlotPoint(i,ssaDa,ssaDb,in); 
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}